#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka import User, utils
from prewikka.templates.MessageListing import MessageListing

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1236548697.9105451
__CHEETAH_genTimestamp__ = 'Sun Mar  8 15:44:57 2009'
__CHEETAH_src__ = 'prewikka/templates/AlertListing.tmpl'
__CHEETAH_srcLastModified__ = 'Mon Jul 30 06:32:48 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class AlertListing(MessageListing):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        MessageListing.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def head_extra_content(self, **KWS):



        ## CHEETAH: generated from #block head_extra_content at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_76531047 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
<script type="text/javascript">

<!-- 
function del_entry(link) {
\trow = link.parentNode.parentNode
\ttable = row.parentNode
\tif ( ! row.nextSibling ) {
                row.previousSibling.lastChild.appendChild(row.lastChild.firstChild)
\t}

\ttable.removeChild(row)\t
}

function end(row) {
\tfield = document.createElement("td")
\tfield.setAttribute("width", "11px")
\trow.appendChild(field)

\tif ( row.firstChild != row.lastChild ) {
\t\tlink = document.createElement("a")
\t\tlink.onclick = function(){ del_entry(this) }
\t\tlink.setAttribute("href", "#")
\t\tcontent = document.createTextNode("-")
\t\tlink.appendChild(content)
\t\tfield.appendChild(link)\t\t
\t} else {
\t\tcontent = document.createTextNode(" ")
\t\tfield.appendChild(content)
\t}
}

function get_operator_option(select, operator)
{
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_76531047
        if False:
            _("Equal")
        if False:
            _("Lesser than")
        if False:
            _("Greater than")
        if False:
            _("Lesser or equal")
        if False:
            _("Greater or equal")
        if False:
            _("Substring")
        if False:
            _("Substring (case-insensitive)")
        if False:
            _("Regular expression")
        if False:
            _("Regular expression (case-insensitive)")
        for operator, desc in (("=", VFFSL(SL,"_",False)("Equal")), ("<", VFFSL(SL,"_",False)("Lesser than")), 
                          (">", VFFSL(SL,"_",False)("Greater than")), ("<=", VFFSL(SL,"_",False)("Lesser or equal")), 
                          (">=", VFFSL(SL,"_",False)("Greater or equal")), ("<>", VFFSL(SL,"_",False)("Substring")), 
			  ("<>*", VFFSL(SL,"_",False)("Substring (case-insensitive)")), ("~", VFFSL(SL,"_",False)("Regular expression")), ("~*", VFFSL(SL,"_",False)("Regular expression (case-insensitive)"))): # generated from line 41, col 1
            write('''        option = document.createElement("option")

        option.setAttribute("value", \'''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 47, col 39
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 47, col 39.
            write('''\')
\toption.setAttribute("title", \'''')
            _v = VFFSL(SL,"desc",True) # '$desc' on line 48, col 32
            if _v is not None: write(_filter(_v, rawExpr='$desc')) # from line 48, col 32.
            write("""')
        if ( operator == '""")
            _v = VFFSL(SL,"operator",True) # '$operator' on line 49, col 27
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 49, col 27.
            write('''\' ) {
                option.setAttribute("selected", "true")
        }
        option_value = document.createTextNode(\'''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 52, col 49
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 52, col 49.
            write("""')
        option.appendChild(option_value)
        select.appendChild(option)
""")
        _orig_filter_70975482 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
}



options_array = new Array()
functions_array = new Array()


function del_td(name, num)
{
        old = document.getElementById("td_" + name + num)
        if ( ! old )
                return

        row = old.parentNode
                
        td = document.createElement("td")
        td.setAttribute("id", "td_" + name + num)

        row.insertBefore(td, old)
        row.removeChild(old)
}


function filter_add_list(value, object, name, num) {
        td = document.getElementById("td_" + name + num)
        
        var opt;

        select = document.createElement("select")
        select.setAttribute("name", name + \'_value_\' + num)
        select.setAttribute("class", "popup_input_field")
        td.appendChild(select)
        
        for (key in options_array[object]) {
                option = document.createElement("option")
                
                if ( options_array[object][key] == value ) {
                        option.setAttribute("selected", "true")
                }
                
                option_value = document.createTextNode(options_array[object][key])
\t        option.appendChild(option_value)
\t        select.appendChild(option)
        }
}

function filter_add_input(value, object, name, num) {
        td = document.getElementById("td_" + name + num)
        
        input = document.createElement("input")
\tinput.setAttribute("class", "popup_input_field")
\tinput.setAttribute("name", name + \'_value_\' + num)
\tinput.setAttribute("type", "text")
\tinput.setAttribute("value", value)
        td.appendChild(input)
}



''')
        for category, aggregations in (
                          ("classification", VFFSL(SL,"classification_aggregations",True)),
                          ("analyzer", VFFSL(SL,"analyzer_aggregations",True)),
                          ("source", VFFSL(SL,"source_aggregations",True)),
                          ("target", VFFSL(SL,"target_aggregations",True))
): # generated from line 118, col 1
            write('''

function aggregated_''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 126, col 21
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 126, col 21.
            write('''_add_entry(path) {
\ttable = document.getElementById("''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 127, col 35
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 127, col 35.
            write('''_aggregation_table")

        if ( table.lastChild && table.lastChild.nodeName == "TR" ) {
                table.lastChild.lastChild.removeChild(table.lastChild.lastChild.lastChild)
        }

        row = document.createElement("tr")
        table.appendChild(row)

        field = document.createElement("th")
        row.appendChild(field)
        content = document.createTextNode("''')
            if False:
                _('Group entry by:')
            _v = VFFSL(SL,"_",False)('Group entry by:') # "$_('Group entry by:')" on line 138, col 44
            if _v is not None: write(_filter(_v, rawExpr="$_('Group entry by:')")) # from line 138, col 44.
            write('''")
        field.appendChild(content)

        field = document.createElement("td")
        row.appendChild(field)
        field = document.createElement("td")
        row.appendChild(field)

        field = document.createElement("td")
        row.appendChild(field)
        select = document.createElement("select")
        field.appendChild(select)

\tselect.setAttribute("class", "popup_input_field")
\tselect.setAttribute("name", "aggregated_''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 152, col 42
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 152, col 42.
            write('''")
        
''')
            for aggregation_name, aggregated_path, unused in VFFSL(SL,"aggregations",True): # generated from line 154, col 9
                write('''
        option = document.createElement("option")

''')
                if VFFSL(SL,"aggregated_path",True) == None: # generated from line 158, col 1
                    write('''        option.setAttribute("disabled", "disabled")
''')
                else: # generated from line 160, col 1
                    write('''        option.setAttribute("value", \'''')
                    _v = VFFSL(SL,"aggregated_path",True) # '$aggregated_path' on line 161, col 39
                    if _v is not None: write(_filter(_v, rawExpr='$aggregated_path')) # from line 161, col 39.
                    write("""')
        if ( path == '""")
                    _v = VFFSL(SL,"aggregated_path",True) # '$aggregated_path' on line 162, col 23
                    if _v is not None: write(_filter(_v, rawExpr='$aggregated_path')) # from line 162, col 23.
                    write('''\' ) {
                option.setAttribute("selected", "true")
        }
''')
                write("""
\toption_value = document.createTextNode('""")
                _v = VFFSL(SL,"aggregation_name",True) # '$aggregation_name' on line 167, col 42
                if _v is not None: write(_filter(_v, rawExpr='$aggregation_name')) # from line 167, col 42.
                write("""')
\toption.appendChild(option_value)
\tselect.appendChild(option)
        
""")
            write('''
\tend(row)
\tfield = document.createElement("td")
\tfield.setAttribute("width", "11px")
\trow.appendChild(field)

\tlink = document.createElement("a")
\tlink.onclick = function(){ aggregated_''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 179, col 40
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 179, col 40.
            write('''_add_entry(\'\') }
\tlink.setAttribute("href", "#")
\tcontent = document.createTextNode("+")
\tlink.appendChild(content)
\tfield.appendChild(link)
}
''')
        write('''
''')
        for name, objects in (
			  ("classification", VFFSL(SL,"classification_filters",True)),
                          ("analyzer", VFFSL(SL,"analyzer_filters",True)), 
                          ("source", VFFSL(SL,"source_filters",True)),
                          ("target", VFFSL(SL,"target_filters",True)),
): # generated from line 187, col 1
            write('''
function ''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 194, col 10
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 194, col 10.
            write("""_add_entry(object, operator, value, num) {
\ttable = document.getElementById('""")
            _v = VFFSL(SL,"name",True) # '${name}' on line 195, col 35
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 195, col 35.
            write('''_table\')

\tif ( table.lastChild && table.lastChild.nodeName == "TR" ) {
\t\ttable.lastChild.lastChild.removeChild(table.lastChild.lastChild.lastChild)
\t}

\trow = document.createElement("tr")
\ttable.appendChild(row)

\tfield = document.createElement("th")
\tcontent = document.createTextNode("''')
            if False:
                _('Filter on:')
            _v = VFFSL(SL,"_",False)('Filter on:') # "$_('Filter on:')" on line 205, col 37
            if _v is not None: write(_filter(_v, rawExpr="$_('Filter on:')")) # from line 205, col 37.
            write('''")
\tfield.appendChild(content)
\trow.appendChild(field)
\t
\tfield = document.createElement("td")
\trow.appendChild(field)
\tselect = document.createElement("select")
\tfield.appendChild(select)

\tselect.setAttribute("class", "popup_select_field")
\tselect.setAttribute("name", "''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 215, col 31
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 215, col 31.
            write('''_object_" + num)
        select.onchange = function() { del_td(\'''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 216, col 48
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 216, col 48.
            write("""', num); functions_array[this.options[this.selectedIndex].value](value, this.options[this.selectedIndex].value, '""")
            _v = VFFSL(SL,"name",True) # '${name}' on line 216, col 168
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 216, col 168.
            write("""', num) }
        
        var add_default
        var add_default_object
        
""")
            for object_name, object, obval in VFFSL(SL,"objects",True)        : # generated from line 221, col 1
                write('''\toption = document.createElement("option")

''')
                if VFFSL(SL,"obval",True) == None: # generated from line 224, col 1
                    write('''        func = filter_add_input
''')
                else: # generated from line 226, col 1
                    write('''        func = filter_add_list
        options_array["''')
                    _v = VFFSL(SL,"object",True) # '$object' on line 228, col 24
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 228, col 24.
                    write('''"] = new Array()

''')
                    cnt = 0
                    for opt in VFFSL(SL,"obval",True): # generated from line 231, col 9
                        write('''                options_array["''')
                        _v = VFFSL(SL,"object",True) # '$object' on line 232, col 32
                        if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 232, col 32.
                        write('''"][''')
                        _v = VFFSL(SL,"cnt",True) # '$cnt' on line 232, col 42
                        if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 232, col 42.
                        write("""] = '""")
                        _v = VFFSL(SL,"opt",True) # '${opt}' on line 232, col 51
                        if _v is not None: write(_filter(_v, rawExpr='${opt}')) # from line 232, col 51.
                        write("""'
""")
                        cnt += 1
                write('''
''')
                if VFFSL(SL,"object",True) == None: # generated from line 237, col 1
                    write('''\toption.setAttribute("disabled", "disabled")
\toption.setAttribute("value", \'\')
''')
                else: # generated from line 240, col 1
                    write('''\toption.setAttribute("value", \'''')
                    _v = VFFSL(SL,"object",True) # '$object' on line 241, col 32
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 241, col 32.
                    write("""')
\tif ( object == '""")
                    _v = VFFSL(SL,"object",True) # '$object' on line 242, col 18
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 242, col 18.
                    write('''\' || ! object ) {
\t\toption.setAttribute("selected", "true")
\t\tadd_default = func
\t\tadd_default_object = \'''')
                    _v = VFFSL(SL,"object",True) # '$object' on line 245, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 245, col 25.
                    write("""'
\t\tobject = '""")
                    _v = VFFSL(SL,"object",True) # '$object' on line 246, col 13
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 246, col 13.
                    write("""'
\t}
""")
                write("""
\toption_value = document.createTextNode('""")
                _v = VFFSL(SL,"object_name",True) # '$object_name' on line 250, col 42
                if _v is not None: write(_filter(_v, rawExpr='$object_name')) # from line 250, col 42.
                write('''\')
\toption.appendChild(option_value)
\tselect.appendChild(option)


        functions_array["''')
                _v = VFFSL(SL,"object",True) # '$object' on line 255, col 26
                if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 255, col 26.
                write('''"] = func
''')
            write('''
        field = document.createElement("td")
        row.appendChild(field)        
        select = document.createElement("select")
        field.appendChild(select)
\tselect.setAttribute("class", "popup_operator_select")
        select.setAttribute("name", "''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 263, col 38
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 263, col 38.
            write('''_operator_" + num)
        
        if ( ! operator )
                operator = "<>*";
                
        get_operator_option(select, operator)

\tfield = document.createElement("td")
\tfield.setAttribute("id", "td_''')
            _v = VFFSL(SL,"name",True) # '$name' on line 271, col 31
            if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 271, col 31.
            write('''" + num)
\trow.appendChild(field)

        if (add_default) {
                add_default(value, add_default_object, \'''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 275, col 57
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 275, col 57.
            write('''\', num);
        }
                
\tend(row)
\t
\tfield = document.createElement("td")
\tfield.setAttribute("width", "11px")
\trow.appendChild(field)
\tlink = document.createElement("a")
\tlink.onclick = function(){ ''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 284, col 29
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 284, col 29.
            write('''_add_entry(\'\', \'\', \'\', (num + 1)) };
\tlink.setAttribute("href", "#")
\tcontent = document.createTextNode("+")
\tlink.appendChild(content)
\tfield.appendChild(link)
}

''')
        write('''//--></script>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_70975482
        _orig_filter_98441609 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_98441609
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_fields_header(self, **KWS):



        ## CHEETAH: generated from #block message_fields_header at line 300, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        self._CHEETAH__globalSetVars["address_cnt"] = 0
        write('''
<thead>
<tr>
  <td class="filter_popup">
    <a onclick="javascript:toggleFilteredColumnVisibility(\'classification\');" href="#">''')
        if False:
            _("Classification")
        _v = VFFSL(SL,"_",False)("Classification") # '$_("Classification")' on line 306, col 88
        if _v is not None: write(_filter(_v, rawExpr='$_("Classification")')) # from line 306, col 88.
        write('''</a>
    <div id="classification">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="classification_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="classification_aggregation_table"></tbody></table></td></tr>
      <tr><td>
      <table class="inline_filter_content">
      <tr>
       <th>''')
        if False:
            _("Type:")
        _v = VFFSL(SL,"_",False)("Type:") # '$_("Type:")' on line 314, col 12
        if _v is not None: write(_filter(_v, rawExpr='$_("Type:")')) # from line 314, col 12.
        write('''</th>
       <td>&nbsp;</td>
''')
        if VFFSL(SL,"correlation_alert_view",True): # generated from line 316, col 7
            disabled = "disabled=\"disabled\""
        else: # generated from line 318, col 7
            disabled = ""
        write('''      
      ''')
        if False:
            N_("Alert")
        if False:
            N_("CorrelationAlert")
        if False:
            N_("OverflowAlert")
        if False:
            N_("ToolAlert")
        for name, path in ((VFFSL(SL,"N_",False)("Alert"), "alert.create_time"), (VFFSL(SL,"N_",False)("CorrelationAlert"), "alert.correlation_alert.name"), 
                          (VFFSL(SL,"N_",False)("OverflowAlert"), "alert.overflow_alert.program"), (VFFSL(SL,"N_",False)("ToolAlert"), "alert.tool_alert.name")): # generated from line 322, col 7
            if path in VFFSL(SL,"alert.type",True): # generated from line 324, col 9
                checked = "checked='checked'"
            else: # generated from line 326, col 9
                checked = ""
            write('''        
        <td>''')
            if False:
                _(VFFSL(SL,"name",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # '$_($name)' on line 330, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($name)')) # from line 330, col 13.
            write('''<input class="checkbox" ''')
            _v = VFFSL(SL,"disabled",True) # '$disabled' on line 330, col 46
            if _v is not None: write(_filter(_v, rawExpr='$disabled')) # from line 330, col 46.
            write(''' type="checkbox" name="alert.type" value="''')
            _v = VFFSL(SL,"path",True) # '$path' on line 330, col 97
            if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 330, col 97.
            write('''" ''')
            _v = VFFSL(SL,"checked",True) # '$checked' on line 330, col 104
            if _v is not None: write(_filter(_v, rawExpr='$checked')) # from line 330, col 104.
            write(''' /></td>
''')
        write('''      </tr>


      <tr>
       <th>''')
        if False:
            _("Severity:")
        _v = VFFSL(SL,"_",False)("Severity:") # '$_("Severity:")' on line 336, col 12
        if _v is not None: write(_filter(_v, rawExpr='$_("Severity:")')) # from line 336, col 12.
        write('''</th>
      ''')
        if False:
            N_("info")
        if False:
            N_("low")
        if False:
            N_("medium")
        if False:
            N_("high")
        if False:
            N_("none")
        for item in VFFSL(SL,"N_",False)("info"), VFFSL(SL,"N_",False)("low"), VFFSL(SL,"N_",False)("medium"), VFFSL(SL,"N_",False)("high"), VFFSL(SL,"N_",False)("none"): # generated from line 337, col 7
            if VFFSL(SL,"item",True) in VFFSL(SL,"alert.assessment.impact.severity",True): # generated from line 338, col 9
                checked = "checked='checked'"
            else: # generated from line 340, col 9
                checked = ""
            write('''        <td>''')
            if False:
                _(VFFSL(SL,"item",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"item",True)) # '$_($item)' on line 343, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($item)')) # from line 343, col 13.
            write('''<input class="checkbox" type="checkbox" name="alert.assessment.impact.severity" value="''')
            _v = VFFSL(SL,"item",True) # '$item' on line 343, col 109
            if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 343, col 109.
            write('''" ''')
            _v = VFFSL(SL,"checked",True) # '$checked' on line 343, col 116
            if _v is not None: write(_filter(_v, rawExpr='$checked')) # from line 343, col 116.
            write(''' /></td>
''')
        write('''      </tr>

      <tr>
       <th>''')
        if False:
            _("Completion:")
        _v = VFFSL(SL,"_",False)("Completion:") # '$_("Completion:")' on line 348, col 12
        if _v is not None: write(_filter(_v, rawExpr='$_("Completion:")')) # from line 348, col 12.
        write('''</th>  
       <td colspan="2">&nbsp;</td>
       
      ''')
        if False:
            N_("succeeded")
        if False:
            N_("failed")
        if False:
            N_("none")
        for item in VFFSL(SL,"N_",False)("succeeded"), VFFSL(SL,"N_",False)("failed"), VFFSL(SL,"N_",False)("none"): # generated from line 351, col 7
            if item in VFFSL(SL,"alert.assessment.impact.completion",True): # generated from line 352, col 9
                checked = "checked='checked'"
            else: # generated from line 354, col 9
                checked = ""
            write('''        <td>''')
            if False:
                _(VFFSL(SL,"item",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"item",True)) # '$_($item)' on line 357, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($item)')) # from line 357, col 13.
            write('''<input class="checkbox" type="checkbox" name="alert.assessment.impact.completion" value="''')
            _v = VFFSL(SL,"item",True) # '$item' on line 357, col 111
            if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 357, col 111.
            write('''" ''')
            _v = VFFSL(SL,"checked",True) # '$checked' on line 357, col 118
            if _v is not None: write(_filter(_v, rawExpr='$checked')) # from line 357, col 118.
            write(''' /></td>
''')
        write('''      
    </tr>
    </table>
      </td></tr>
     </table>

      <script type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"classification",True): # generated from line 367, col 9
            write('''          classification_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 368, col 37
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 368, col 37.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 368, col 48
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 368, col 48.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 368, col 61
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 368, col 61.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 368, col 95
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 368, col 95.
            write(''')
''')
            cnt = VFFSL(SL,"cnt",True) + 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_classification",True)) == 0: # generated from line 372, col 7
            write('''        aggregated_classification_add_entry("")
''')
        else: # generated from line 374, col 7
            for path in VFFSL(SL,"aggregated_classification",True): # generated from line 375, col 9
                write("""          aggregated_classification_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 376, col 48
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 376, col 48.
                write("""')
""")
        write('''      </script>
    </div>

''')
        if VFFSL(SL,"classification_filtered",True): # generated from line 382, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </td>

  <td class="filter_popup">
    <a onclick="javascript:toggleFilteredColumnVisibility(\'source\');" href="#">''')
        if False:
            _("Source")
        _v = VFFSL(SL,"_",False)("Source") # '$_("Source")' on line 388, col 80
        if _v is not None: write(_filter(_v, rawExpr='$_("Source")')) # from line 388, col 80.
        write('''</a>
    <div id="source">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="source_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="source_aggregation_table"></tbody></table></td></tr>
     </table>
     
     <script type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"source",True): # generated from line 397, col 9
            write('''          source_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 398, col 29
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 398, col 29.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 398, col 40
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 398, col 40.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 398, col 53
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 398, col 53.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 398, col 87
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 398, col 87.
            write(''')
''')
            cnt += 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_source",True)) == 0: # generated from line 402, col 7
            write('''        aggregated_source_add_entry("")
''')
        else: # generated from line 404, col 7
            for path in VFFSL(SL,"aggregated_source",True): # generated from line 405, col 9
                write("""          aggregated_source_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 406, col 40
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 406, col 40.
                write("""')
""")
        write('''     </script>
    </div>
''')
        if VFFSL(SL,"source_filtered",True): # generated from line 411, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </td>

  <td class="filter_popup">
    <a onclick="javascript:toggleFilteredColumnVisibility(\'target\');" href="#">''')
        if False:
            _("Target")
        _v = VFFSL(SL,"_",False)("Target") # '$_("Target")' on line 417, col 80
        if _v is not None: write(_filter(_v, rawExpr='$_("Target")')) # from line 417, col 80.
        write('''</a>
    <div id="target">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="target_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="target_aggregation_table"></tbody></table></td></tr>
     </table>
     <script type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"target",True): # generated from line 425, col 9
            write('''          target_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 426, col 29
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 426, col 29.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 426, col 40
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 426, col 40.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 426, col 53
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 426, col 53.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 426, col 87
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 426, col 87.
            write(''')
''')
            cnt = VFFSL(SL,"cnt",True) + 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_target",True)) == 0: # generated from line 430, col 7
            write('''        aggregated_target_add_entry("")
''')
        else: # generated from line 432, col 7
            for path in VFFSL(SL,"aggregated_target",True): # generated from line 433, col 9
                write("""          aggregated_target_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 434, col 40
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 434, col 40.
                write("""')
""")
        write('''     </script>
    </div>
''')
        if VFFSL(SL,"target_filtered",True): # generated from line 439, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </td>
  
  <td class="filter_popup">
    <a onclick="javascript:toggleFilteredColumnVisibility(\'analyzer\');" href="#">''')
        if False:
            _("Sensor")
        _v = VFFSL(SL,"_",False)("Sensor") # '$_("Sensor")' on line 445, col 82
        if _v is not None: write(_filter(_v, rawExpr='$_("Sensor")')) # from line 445, col 82.
        write('''</a>
    <div id="analyzer">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="analyzer_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="analyzer_aggregation_table"></tbody></table></td></tr>
     </table>

     <script  type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"analyzer",True): # generated from line 454, col 7
            write('''       analyzer_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 455, col 28
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 455, col 28.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 455, col 39
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 455, col 39.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 455, col 52
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 455, col 52.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 455, col 86
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 455, col 86.
            write(''')
''')
            cnt = VFFSL(SL,"cnt",True) + 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_analyzer",True)) == 0: # generated from line 459, col 7
            write('''        aggregated_analyzer_add_entry("")
''')
        else: # generated from line 461, col 7
            for path in VFFSL(SL,"aggregated_analyzer",True): # generated from line 462, col 9
                write("""          aggregated_analyzer_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 463, col 42
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 463, col 42.
                write("""')
""")
        write('''     </script>
    </div>
''')
        if VFFSL(SL,"analyzer_filtered",True): # generated from line 468, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </td>

  <td>''')
        if False:
            _("Time")
        _v = VFFSL(SL,"_",False)("Time") # '$_("Time")' on line 473, col 7
        if _v is not None: write(_filter(_v, rawExpr='$_("Time")')) # from line 473, col 7.
        write('''</td>

  <td>
    <input src="prewikka/images/search.png" type="image" style="border: 0;" />
  </td>
</tr>
</thead>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_fields(self, **KWS):



        ## CHEETAH: generated from #block message_fields at line 483, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_26181936 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
<td>
''')
        if VFFSL(SL,"message.sub_alert_name",True): # generated from line 487, col 3
            write('''    <b>''')
            _v = VFFSL(SL,"message.sub_alert_type",True) # '$message.sub_alert_type' on line 488, col 8
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_type')) # from line 488, col 8.
            if VFFSL(SL,"message.sub_alert_display",True): # generated from line 489, col 5
                write('''      ''')
                if False:
                    ngettext("alert", "alerts", VFFSL(SL,"message.sub_alert_number",True))
                string = VFFSL(SL,"ngettext",False)("alert", "alerts", VFFSL(SL,"message.sub_alert_number",True))
                write('''      (<a href="''')
                _v = VFFSL(SL,"message.sub_alert_display",True) # '$message.sub_alert_display' on line 491, col 17
                if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_display')) # from line 491, col 17.
                write('''">''')
                _v = VFFSL(SL,"message.sub_alert_number",True) # '$message.sub_alert_number' on line 491, col 45
                if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_number')) # from line 491, col 45.
                write('''</a> ''')
                _v = VFFSL(SL,"string",True) # '$string' on line 491, col 75
                if _v is not None: write(_filter(_v, rawExpr='$string')) # from line 491, col 75.
                write(''')''')
            write(''':</b> <i><a href="''')
            _v = VFFSL(SL,"message.sub_alert_link",True) # '$message.sub_alert_link' on line 493, col 19
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_link')) # from line 493, col 19.
            write('''">''')
            _v = VFFSL(SL,"message.sub_alert_name",True) # '$message.sub_alert_name' on line 493, col 44
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_name')) # from line 493, col 44.
            write('''</a></i><br/>''')
        write('''
''')
        if VFFSL(SL,"message.aggregated",True) and VFFSL(SL,"message.aggregated_classifications_hidden",True) > 0: # generated from line 496, col 3
            write('''    ''')
            if False:
                _("%(hidden)d of %(total)d alerts not shown...")
            string = VFFSL(SL,"_",False)("%(hidden)d of %(total)d alerts not shown...")
            write('''    <b>(''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"string",True) % { "hidden": VFFSL(SL,"message.aggregated_classifications_hidden",True), "total": VFFSL(SL,"message.aggregated_classifications_total",True) }) # '$str($string % { "hidden": $message.aggregated_classifications_hidden, "total": $message.aggregated_classifications_total })' on line 498, col 9
            if _v is not None: write(_filter(_v, rawExpr='$str($string % { "hidden": $message.aggregated_classifications_hidden, "total": $message.aggregated_classifications_total })')) # from line 498, col 9.
            write('''
    <a href="''')
            _v = VFFSL(SL,"message.aggregated_classifications_hidden_expand",True) # '$message.aggregated_classifications_hidden_expand' on line 499, col 14
            if _v is not None: write(_filter(_v, rawExpr='$message.aggregated_classifications_hidden_expand')) # from line 499, col 14.
            write('''">''')
            if False:
                _("expand")
            _v = VFFSL(SL,"_",False)("expand") # '$_("expand")' on line 499, col 65
            if _v is not None: write(_filter(_v, rawExpr='$_("expand")')) # from line 499, col 65.
            write('''</a>)</b>
    <br/>
''')
        write('''
''')
        for info in VFFSL(SL,"message.infos",True): # generated from line 503, col 3
            if VFFSL(SL,"message.aggregated",True) and (len(VFFSL(SL,"message.infos",True)) > 1 or VFFSL(SL,"info.count",True) > 1): # generated from line 504, col 5
                write('''      ''')
                _v = VFFSL(SL,"info.count",True) # '$info.count' on line 505, col 7
                if _v is not None: write(_filter(_v, rawExpr='$info.count')) # from line 505, col 7.
                write(''' x
''')
            write('''    
''')
            if VFFSL(SL,"info.classification.value",True): # generated from line 508, col 5
                write('''      <a class="impact_severity_''')
                _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 509, col 33
                if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 509, col 33.
                write('''" href="''')
                _v = VFFSL(SL,"info.display",True) # '$info.display' on line 509, col 61
                if _v is not None: write(_filter(_v, rawExpr='$info.display')) # from line 509, col 61.
                write('''">''')
                _v = VFFSL(SL,"info.classification.value",True) # '$info.classification.value' on line 509, col 76
                if _v is not None: write(_filter(_v, rawExpr='$info.classification.value')) # from line 509, col 76.
                write('''</a>
''')
            else: # generated from line 510, col 5
                write('''      <a class="impact_severity_''')
                _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 511, col 33
                if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 511, col 33.
                write('''" href="''')
                _v = VFFSL(SL,"info.display",True) # '$info.display' on line 511, col 61
                if _v is not None: write(_filter(_v, rawExpr='$info.display')) # from line 511, col 61.
                write('''">n/a</a>
''')
            write('''
''')
            if VFFSL(SL,"info.completion.value",True): # generated from line 514, col 5
                write('''      (<span class="impact_completion_''')
                _v = VFFSL(SL,"info.completion.value",True) # '$info.completion.value' on line 515, col 39
                if _v is not None: write(_filter(_v, rawExpr='$info.completion.value')) # from line 515, col 39.
                write('''">''')
                _v = VFFSL(SL,"info.completion.value",True) # '$info.completion.value' on line 515, col 63
                if _v is not None: write(_filter(_v, rawExpr='$info.completion.value')) # from line 515, col 63.
                write('''</span>)
''')
            write('''
    <br/>
''')
            sep = "("
            for url, name in VFFSL(SL,"info.classification_references",True): # generated from line 520, col 1
                if VFFSL(SL,"url",True): # generated from line 521, col 1
                    _v = VFFSL(SL,"sep",True) # '$sep' on line 521, col 10
                    if _v is not None: write(_filter(_v, rawExpr='$sep')) # from line 521, col 10.
                    write('''<a target="''')
                    _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 521, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 521, col 25.
                    write('''" href="''')
                    _v = VFFSL(SL,"url",True) # '$url' on line 521, col 63
                    if _v is not None: write(_filter(_v, rawExpr='$url')) # from line 521, col 63.
                    write('''">''')
                    _v = VFFSL(SL,"name",True) # '$name' on line 521, col 69
                    if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 521, col 69.
                    write('''</a>''')
                else: # generated from line 521, col 78
                    _v = VFFSL(SL,"sep",True) # '$sep' on line 521, col 84
                    if _v is not None: write(_filter(_v, rawExpr='$sep')) # from line 521, col 84.
                    _v = VFFSL(SL,"name",True) # '$name' on line 521, col 88
                    if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 521, col 88.
                sep = ", "
            if VFFSL(SL,"info.classification_references",True): # generated from line 523, col 10
                write(''')''')
            write('''
''')
        write('''</td>

''')
        if False:
            _("source")
        if False:
            _("target")
        for name, direction, hidden, total, expand in (VFFSL(SL,"_",False)("source"), VFFSL(SL,"message.source",True), VFFSL(SL,"message.aggregated_source_hidden",True), VFFSL(SL,"message.aggregated_source_total",True), VFFSL(SL,"message.aggregated_source_expand",True)), (VFFSL(SL,"_",False)("target"), VFFSL(SL,"message.target",True), VFFSL(SL,"message.aggregated_target_hidden",True), VFFSL(SL,"message.aggregated_target_total",True), VFFSL(SL,"message.aggregated_target_expand",True)): # generated from line 527, col 1
            write('''<td>
''')
            if len(VFFSL(SL,"direction",True)) == 0: # generated from line 529, col 1
                write('''       n/a
''')
            write('''
''')
            need_hr = 0
            write('''
''')
            if VFFSL(SL,"hidden",True) > 0: # generated from line 535, col 1
                write('''       ''')
                if False:
                    _("%(hidden)d of %(total)d %(name)ss not shown...")
                string = VFFSL(SL,"_",False)("%(hidden)d of %(total)d %(name)ss not shown...")
                write('''       <b>(''')
                _v = VFFSL(SL,"str",False)(VFFSL(SL,"string",True) % { "hidden": VFFSL(SL,"hidden",True), "total": VFFSL(SL,"total",True), "name": VFFSL(SL,"name",True) }) # '$str($string % { "hidden": $hidden, "total": $total, "name": $name })' on line 537, col 12
                if _v is not None: write(_filter(_v, rawExpr='$str($string % { "hidden": $hidden, "total": $total, "name": $name })')) # from line 537, col 12.
                write('''
       <a href="''')
                _v = VFFSL(SL,"expand",True) # '$expand' on line 538, col 17
                if _v is not None: write(_filter(_v, rawExpr='$expand')) # from line 538, col 17.
                write('''">''')
                if False:
                    _("expand")
                _v = VFFSL(SL,"_",False)("expand") # '$_("expand")' on line 538, col 26
                if _v is not None: write(_filter(_v, rawExpr='$_("expand")')) # from line 538, col 26.
                write('''</a>)</b>
       <br/>
''')
            write('''
''')
            for direction in VFFSL(SL,"direction",True) : # generated from line 542, col 1
                if VFFSL(SL,"need_hr",True): # generated from line 543, col 7
                    write('''\t<hr style="border: 1px dashed #808080; margin-top: 3px; margin-bottom: 0px;" />
''')
                write('''
''')
                need_hr = 1
                service = ""
                proto_param = ""
                proto_str = ""
                write('''    
''')
                if VFFSL(SL,"direction.protocol.value",True) != None: # generated from line 552, col 7
                    proto_str = VFN(VFFSL(SL,"direction.protocol.value",True),"lower",False)()
                    proto_param = "&amp;protocol=" + VFN(VFFSL(SL,"direction.protocol.value",True),"upper",False)()
                write('''
''')
                for address in VFFSL(SL,"direction.addresses",True): # generated from line 557, col 7
                    write('''       <a href="#" onclick="javascript:toggleVisibilityUnique(\'menu_''')
                    _v = VFFSL(SL,"address_cnt",True) # '$address_cnt' on line 558, col 69
                    if _v is not None: write(_filter(_v, rawExpr='$address_cnt')) # from line 558, col 69.
                    write('''\'); return false;">''')
                    _v = VFFSL(SL,"address.value",True) # '$address.value' on line 558, col 100
                    if _v is not None: write(_filter(_v, rawExpr='$address.value')) # from line 558, col 100.
                    write('''</a>''')
                    if VFFSL(SL,"direction.service.value",True) != None: # generated from line 559, col 8
                        write(''':<a target="''')
                        _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 560, col 13
                        if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 560, col 13.
                        write('''" href="https://www.prelude-ids.com/port_details.php?port=''')
                        _v = VFFSL(SL,"str",False)(VFFSL(SL,"direction.service.value",True)) # '$str($direction.service.value)' on line 560, col 101
                        if _v is not None: write(_filter(_v, rawExpr='$str($direction.service.value)')) # from line 560, col 101.
                        _v = VFFSL(SL,"proto_param",True) # '$proto_param' on line 560, col 131
                        if _v is not None: write(_filter(_v, rawExpr='$proto_param')) # from line 560, col 131.
                        write('''">''')
                        _v = VFFSL(SL,"str",False)(VFFSL(SL,"direction.service.value",True)) # '$str($direction.service.value)' on line 560, col 145
                        if _v is not None: write(_filter(_v, rawExpr='$str($direction.service.value)')) # from line 560, col 145.
                        if VFFSL(SL,"proto_str",True): # generated from line 561, col 10
                            write('''/''')
                            _v = VFFSL(SL,"proto_str",True) # '$proto_str' on line 562, col 2
                            if _v is not None: write(_filter(_v, rawExpr='$proto_str')) # from line 562, col 2.
                            write('''</a>
''')
                        else : # generated from line 563, col 10
                            write('''</a>
''')
                    elif VFFSL(SL,"proto_str",True): # generated from line 566, col 8
                        write(''':''')
                        _v = VFFSL(SL,"proto_str",True) # '$proto_str' on line 567, col 2
                        if _v is not None: write(_filter(_v, rawExpr='$proto_str')) # from line 567, col 2.
                        write('''
''')
                    write('''<br />

       <span id="menu_''')
                    _v = VFFSL(SL,"address_cnt",True) # '$address_cnt' on line 571, col 23
                    if _v is not None: write(_filter(_v, rawExpr='$address_cnt')) # from line 571, col 23.
                    write('''" class="popup_menu">
''')
                    self._CHEETAH__globalSetVars["address_cnt"] += 1
                    write('''
         - <a href="''')
                    _v = VFFSL(SL,"address.inline_filter",True) # '$address.inline_filter' on line 574, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$address.inline_filter')) # from line 574, col 21.
                    write('''">''')
                    if False:
                        _("Filter on this %s")
                    _v = VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("Filter on this %s") % (VFFSL(SL,"name",True))) # '$str($_("Filter on this %s") % ($name))' on line 574, col 45
                    if _v is not None: write(_filter(_v, rawExpr='$str($_("Filter on this %s") % ($name))')) # from line 574, col 45.
                    write('''</a><br />
 
''')
                    if not VFFSL(SL,"address.category",True) or VFFSL(SL,"address.category",True) in ("ipv4-addr", "ipv4-net", "ipv6-addr", "ipv6-net"): # generated from line 576, col 8
                        write('''         - <a target="''')
                        _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 577, col 23
                        if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 577, col 23.
                        write('''" href="https://www.prelude-ids.com/host_details.php?host=''')
                        _v = VFFSL(SL,"address.value",True) # '$address.value' on line 577, col 111
                        if _v is not None: write(_filter(_v, rawExpr='$address.value')) # from line 577, col 111.
                        write('''">''')
                        if False:
                            _("%s information")
                        _v = VFN(VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("%s information") % (VFFSL(SL,"name",True))),"capitalize",False)() # '$str($_("%s information") % ($name)).capitalize()' on line 577, col 127
                        if _v is not None: write(_filter(_v, rawExpr='$str($_("%s information") % ($name)).capitalize()')) # from line 577, col 127.
                        write('''</a><br />

''')
                        for cmdname, link in VFFSL(SL,"address.host_commands",True): # generated from line 579, col 11
                            write('''         - <a href="''')
                            _v = VFFSL(SL,"link",True) # '$link' on line 580, col 21
                            if _v is not None: write(_filter(_v, rawExpr='$link')) # from line 580, col 21.
                            write('''">''')
                            _v = VFFSL(SL,"cmdname",True) # '$cmdname' on line 580, col 28
                            if _v is not None: write(_filter(_v, rawExpr='$cmdname')) # from line 580, col 28.
                            write('''</a><br />
''')
                    write('''
       </span>
''')
                write('''     
''')
                if VFFSL(SL,"len",False)(VFFSL(SL,"direction.addresses",True)) == 0 and VFFSL(SL,"service",True): # generated from line 587, col 7
                    write('''\tservice: ''')
                    _v = VFFSL(SL,"service",True)[1:] # '$service[1:]' on line 588, col 11
                    if _v is not None: write(_filter(_v, rawExpr='$service[1:]')) # from line 588, col 11.
                    write('''
''')
                write('''
''')
                cnt = 0
                for name, value, extra in VFFSL(SL,"direction.listed_values",True): # generated from line 592, col 6
                    if VFFSL(SL,"cnt",True) > 0: # generated from line 593, col 10
                        write('''          <br />
''')
                    write('''
         ''')
                    _v = VFFSL(SL,"name",True) # '$name' on line 597, col 10
                    if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 597, col 10.
                    write(''': <a href="''')
                    _v = VFFSL(SL,"value.inline_filter",True) # '$value.inline_filter' on line 597, col 26
                    if _v is not None: write(_filter(_v, rawExpr='$value.inline_filter')) # from line 597, col 26.
                    write('''">''')
                    _v = VFFSL(SL,"value.value",True) # '$value.value' on line 597, col 48
                    if _v is not None: write(_filter(_v, rawExpr='$value.value')) # from line 597, col 48.
                    write('''</a>
''')
                    if VFFSL(SL,"extra",True) != None: # generated from line 598, col 10
                        write('''          (''')
                        _v = VFFSL(SL,"extra",True) # '$extra' on line 599, col 12
                        if _v is not None: write(_filter(_v, rawExpr='$extra')) # from line 599, col 12.
                        write(''')
''')
                    write('''         
''')
                    cnt += 1
            write('''
</td>
''')
        write('''
<td>
''')
        for sensor in VFFSL(SL,"message.sensors",True): # generated from line 610, col 3
            write('''    <a href="''')
            _v = VFFSL(SL,"sensor.name.inline_filter",True) # '$sensor.name.inline_filter' on line 611, col 14
            if _v is not None: write(_filter(_v, rawExpr='$sensor.name.inline_filter')) # from line 611, col 14.
            write('''">''')
            _v = VFFSL(SL,"sensor.name.value",True) # '$sensor.name.value' on line 611, col 42
            if _v is not None: write(_filter(_v, rawExpr='$sensor.name.value')) # from line 611, col 42.
            write('''</a>
''')
            if VFFSL(SL,"sensor.node_name.value",True): # generated from line 612, col 5
                write('''      (<a href="''')
                _v = VFFSL(SL,"sensor.node_name.inline_filter",True) # '$sensor.node_name.inline_filter' on line 613, col 17
                if _v is not None: write(_filter(_v, rawExpr='$sensor.node_name.inline_filter')) # from line 613, col 17.
                write('''">''')
                _v = VFFSL(SL,"sensor.node_name.value",True) # '$sensor.node_name.value' on line 613, col 50
                if _v is not None: write(_filter(_v, rawExpr='$sensor.node_name.value')) # from line 613, col 50.
                write('''</a>)
''')
            write('''    <br/>
''')
        write('''</td>
<td>
''')
        if VFFSL(SL,"message.aggregated",True): # generated from line 619, col 3
            if VFFSL(SL,"message.time_min.value",True) == VFFSL(SL,"message.time_max.value",True): # generated from line 620, col 5
                write('''      ''')
                _v = VFFSL(SL,"message.time_min.value",True) # '$message.time_min.value' on line 621, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_min.value')) # from line 621, col 7.
                write('''
''')
            else: # generated from line 622, col 5
                write('''      ''')
                _v = VFFSL(SL,"message.time_max.value",True) # '$message.time_max.value' on line 623, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_max.value')) # from line 623, col 7.
                write(''' -
      ''')
                _v = VFFSL(SL,"message.time_min.value",True) # '$message.time_min.value' on line 624, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_min.value')) # from line 624, col 7.
                write('''
''')
        else: # generated from line 626, col 3
            write('''    ''')
            _v = VFFSL(SL,"message.time.value",True) # '$message.time.value' on line 627, col 5
            if _v is not None: write(_filter(_v, rawExpr='$message.time.value')) # from line 627, col 5.
            write('''
''')
            if VFFSL(SL,"message.analyzer_time.value",True): # generated from line 628, col 5
                write('''      (sent at ''')
                _v = VFFSL(SL,"message.analyzer_time.value",True) # '$message.analyzer_time.value' on line 629, col 16
                if _v is not None: write(_filter(_v, rawExpr='$message.analyzer_time.value')) # from line 629, col 16.
                write(''')
''')
        write('''</td>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_26181936
        _orig_filter_81453945 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_81453945
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def timeline_extra_content(self, **KWS):



        ## CHEETAH: generated from #block timeline_extra_content at line 638, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_19514595 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''<tr>
  <th id="filter_control_label">''')
        if False:
            _("Filter")
        _v = VFFSL(SL,"_",False)("Filter") # '$_("Filter")' on line 641, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Filter")')) # from line 641, col 33.
        write('''</th>
  <td colspan="2">
   <select name="filter" size="1" class="filter_control_select">
    <option value="">&nbsp;</option>
''')
        for fltr in VFFSL(SL,"filters",True): # generated from line 645, col 3
            write('''    <option value="''')
            _v = VFFSL(SL,"fltr",True) # '$fltr' on line 646, col 20
            if _v is not None: write(_filter(_v, rawExpr='$fltr')) # from line 646, col 20.
            write('''" ''')
            if VFFSL(SL,"fltr",True) == VFFSL(SL,"current_filter",True): # generated from line 646, col 27
                write(''' selected="selected" ''')
            write('''>''')
            _v = VFFSL(SL,"fltr",True) # '$fltr' on line 646, col 86
            if _v is not None: write(_filter(_v, rawExpr='$fltr')) # from line 646, col 86.
            write('''</option>
''')
        write('''  </select>
 </td>
</tr>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_19514595
        _orig_filter_21586853 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_21586853
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        self.head_extra_content(trans=trans)
        write('''

''')
        self.message_fields_header(trans=trans)
        write('''

''')
        self.message_fields(trans=trans)
        write('''
''')
        self.timeline_extra_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_AlertListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(AlertListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(AlertListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(AlertListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=AlertListing()).run()


