#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.ClassicLayout import ClassicLayout
from prewikka.views.sensor import node_cmp
from prewikka.views.sensor import analyzer_cmp
from prewikka.views.sensor import getDominantStatus

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1236548700.0343521
__CHEETAH_genTimestamp__ = 'Sun Mar  8 15:45:00 2009'
__CHEETAH_src__ = 'prewikka/templates/SensorListing.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Aug  1 13:14:00 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class SensorListing(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        ClassicLayout.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def layout_start_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_start_hook at line 6, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<script type="text/javascript">
<!--

function showRowsByClass(id, wanted) {
    var div = document.getElementById(id);
    var table = document.getElementById(\'table_\' + id);
    var rows  = table.getElementsByTagName(\'tr\');

    for ( var i = 0; i < rows.length; i++ ) {
        tr_class = rows[i].className.split(\' \')[0];

        if ( tr_class != wanted && tr_class != \'tr_header\' )
            rows[i].style.display = "none";
        else
            rows[i].style.display = "";
    }

    div.style.display = "block";
}

function showRowsAll(id) {
    var div = document.getElementById(id);
    var table = document.getElementById(\'table_\' + id);
    var rows  = table.getElementsByTagName(\'tr\');
    var some_hidden = false;

    for ( var i = 0; i < rows.length; i++ ) {
        if ( rows[i].style.display == "none" )
            some_hidden = true;

        rows[i].style.display = "";
    }

    if ( some_hidden || div.style.display == "none" )
        div.style.display = "block";
    else
        div.style.display = "none";
}

//--></script>

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 50, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_42738897 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
''')
        if len(VFFSL(SL,"locations",True)) > 0: # generated from line 53, col 1
            write(''' <form action="?" method="post">
 <input type="hidden" name="view" value="sensor_messages_delete" />
''')
        write('''
<div id="fieldset_page">

''')
        listing = VFN(VFFSL(SL,"locations",True),"keys",False)()
        _v = VFN(VFFSL(SL,"listing",True),"sort",False)() # '$listing.sort()' on line 61, col 1
        if _v is not None: write(_filter(_v, rawExpr='$listing.sort()')) # from line 61, col 1.
        write('''

''')
        for entry in VFFSL(SL,"listing",True): # generated from line 63, col 1
            write(''' <fieldset class="fieldset_heading">
''')
            dominant = VFFSL(SL,"getDominantStatus",False)(VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)])
            dclass = "heartbeat_analyze_sensor_status_" + VFFSL(SL,"dominant",True)
            write('''
''')
            if VFFSL(SL,"dominant",True) != "online": # generated from line 68, col 3
                display = "block"
                display_tmp = "none"
            else: # generated from line 71, col 3
                display = "none"
                display_tmp = "block"
            write('''
  <legend>
   <b>
    <a href="#" onclick="javascript:toggleVisibility(\'''')
            _v = VFFSL(SL,"entry",True) # '${entry}' on line 78, col 55
            if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 78, col 55.
            write("""_tmp'); toggleVisibility('""")
            _v = VFFSL(SL,"entry",True) # '${entry}' on line 78, col 89
            if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 78, col 89.
            write('''\'); return false;">''')
            _v = VFFSL(SL,"entry",True) # '$entry' on line 78, col 116
            if _v is not None: write(_filter(_v, rawExpr='$entry')) # from line 78, col 116.
            write('''</a>
   </b>
  </legend>

   <div id="''')
            _v = VFFSL(SL,"entry",True) # '${entry}' on line 82, col 13
            if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 82, col 13.
            write('''_tmp" style="display: ''')
            _v = VFFSL(SL,"display_tmp",True) # '$display_tmp' on line 82, col 43
            if _v is not None: write(_filter(_v, rawExpr='$display_tmp')) # from line 82, col 43.
            write('''" class="''')
            _v = VFFSL(SL,"dclass",True) # '$dclass' on line 82, col 64
            if _v is not None: write(_filter(_v, rawExpr='$dclass')) # from line 82, col 64.
            write('''">
    <table style="border: 1px solid black;">
     <tr class="nodash">
      <td style="background-color: white; width:150px;">
''')
            nlen = VFFSL(SL,"len",False)(VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["nodes"])
            alen = VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["total"]
            write('''       ''')
            if False:
                ngettext("%d Node", "%d Nodes", VFFSL(SL,"nlen",True))
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"ngettext",False)("%d Node", "%d Nodes", VFFSL(SL,"nlen",True)) % VFFSL(SL,"nlen",True)) # '$str($ngettext("%d Node", "%d Nodes", $nlen) % $nlen)' on line 88, col 8
            if _v is not None: write(_filter(_v, rawExpr='$str($ngettext("%d Node", "%d Nodes", $nlen) % $nlen)')) # from line 88, col 8.
            write(''', ''')
            if False:
                ngettext("%d Analyzer", "%d Analyzers", VFFSL(SL,"alen",True))
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"ngettext",False)("%d Analyzer", "%d Analyzers", VFFSL(SL,"alen",True)) % VFFSL(SL,"alen",True)) # '$str($ngettext("%d Analyzer", "%d Analyzers", $alen) % $alen)' on line 88, col 63
            if _v is not None: write(_filter(_v, rawExpr='$str($ngettext("%d Analyzer", "%d Analyzers", $alen) % $alen)')) # from line 88, col 63.
            write('''
      </td>
       ''')
            if False:
                ngettext("%d Online", "%d Onlines", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["online"])
            if False:
                ngettext("%d Offline", "%d Offlines", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["offline"])
            if False:
                ngettext("%d Unknown", "%d Unknowns", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["unknown"])
            if False:
                ngettext("%d Missing", "%d Missings", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["missing"])
            for i in ( ("online",  VFFSL(SL,"ngettext",False)("%d Online", "%d Onlines", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["online"])),
                    ("offline", VFFSL(SL,"ngettext",False)("%d Offline", "%d Offlines", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["offline"])),
                    ("unknown", VFFSL(SL,"ngettext",False)("%d Unknown", "%d Unknowns", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["unknown"])),
                    ("missing", VFFSL(SL,"ngettext",False)("%d Missing", "%d Missings", VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["missing"]))): # generated from line 90, col 8
                if VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)][VFFSL(SL,"i",True)[0]] > 0: # generated from line 94, col 9
                    write('''      <td class="heartbeat_analyze_sensor_status_''')
                    _v = VFFSL(SL,"i",True)[0] # '$i[0]' on line 95, col 50
                    if _v is not None: write(_filter(_v, rawExpr='$i[0]')) # from line 95, col 50.
                    write('''">''')
                    _v = VFFSL(SL,"str",False)(VFFSL(SL,"i",True)[1] % VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)][VFFSL(SL,"i",True)[0]]) # '$str($i[1] % $locations[$entry][$i[0]])' on line 95, col 57
                    if _v is not None: write(_filter(_v, rawExpr='$str($i[1] % $locations[$entry][$i[0]])')) # from line 95, col 57.
                    write('''</td>
''')
            write('''     </tr>
    </table>
   </div>

   <div id="''')
            _v = VFFSL(SL,"entry",True) # '$entry' on line 102, col 13
            if _v is not None: write(_filter(_v, rawExpr='$entry')) # from line 102, col 13.
            write('''" style="display: ''')
            _v = VFFSL(SL,"display",True) # '$display' on line 102, col 37
            if _v is not None: write(_filter(_v, rawExpr='$display')) # from line 102, col 37.
            write('''">
''')
            nlisting = VFN(VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["nodes"],"values",False)()
            write('''   ''')
            _v = VFN(VFFSL(SL,"nlisting",True),"sort",False)(node_cmp) # '$nlisting.sort(node_cmp)' on line 104, col 4
            if _v is not None: write(_filter(_v, rawExpr='$nlisting.sort(node_cmp)')) # from line 104, col 4.
            write('''

''')
            for node in VFFSL(SL,"nlisting",True): # generated from line 106, col 4
                cnt = 0
                row_classes = ("table_row_even", "table_row_odd")
                row_class = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True)%2]
                dominant = VFFSL(SL,"getDominantStatus",False)(VFFSL(SL,"node",True))
                dclass = "heartbeat_analyze_sensor_status_" + dominant
                write('''
''')
                if VFFSL(SL,"dominant",True) != "online": # generated from line 113, col 5
                    display = "block"
                else: # generated from line 115, col 5
                    display = "none"
                write('''
    <table style="width:100%; border: 1px solid black;">
     <thead style="width: 100%;">
      <tr class="''')
                _v = VFFSL(SL,"dclass",True) # '$dclass' on line 121, col 18
                if _v is not None: write(_filter(_v, rawExpr='$dclass')) # from line 121, col 18.
                write('''">
        <th>''')
                _v = VFFSL(SL,"node.node_name",True) # '$node.node_name' on line 122, col 13
                if _v is not None: write(_filter(_v, rawExpr='$node.node_name')) # from line 122, col 13.
                write('''</th>
        <th>
''')
                for addr in VFFSL(SL,"node.node_addresses",True): # generated from line 124, col 10
                    write('''          <a href="#" onclick="javascript:toggleVisibilityUnique(\'''')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 125, col 67
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 125, col 67.
                    write('''_''')
                    _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 125, col 76
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 125, col 76.
                    write('''_addr\'); return false;">''')
                    _v = VFFSL(SL,"addr.value",True) # '$addr.value' on line 125, col 116
                    if _v is not None: write(_filter(_v, rawExpr='$addr.value')) # from line 125, col 116.
                    write('''</a><br />
          <span id="''')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 126, col 21
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 126, col 21.
                    write('''_''')
                    _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 126, col 30
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 126, col 30.
                    write('''_addr" class="popup_menu">
           - <a href="''')
                    _v = VFFSL(SL,"addr.inline_filter",True) # '$addr.inline_filter' on line 127, col 23
                    if _v is not None: write(_filter(_v, rawExpr='$addr.inline_filter')) # from line 127, col 23.
                    write('''">''')
                    if False:
                        _("Filter on address")
                    _v = VFFSL(SL,"_",False)("Filter on address") # '$_("Filter on address")' on line 127, col 44
                    if _v is not None: write(_filter(_v, rawExpr='$_("Filter on address")')) # from line 127, col 44.
                    write('''</a><br />
           - <a target="''')
                    _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 128, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 128, col 25.
                    write('''" href="https://www.prelude-ids.com/host_details.php?host=''')
                    _v = VFFSL(SL,"addr.value",True) # '$addr.value' on line 128, col 113
                    if _v is not None: write(_filter(_v, rawExpr='$addr.value')) # from line 128, col 113.
                    write('''">''')
                    if False:
                        _("Address information")
                    _v = VFFSL(SL,"_",False)("Address information") # '$_("Address information")' on line 128, col 126
                    if _v is not None: write(_filter(_v, rawExpr='$_("Address information")')) # from line 128, col 126.
                    write('''</a><br />

''')
                    for name, link in VFFSL(SL,"addr.host_commands",True): # generated from line 130, col 12
                        write('''           - <a href="''')
                        _v = VFFSL(SL,"link",True) # '$link' on line 131, col 23
                        if _v is not None: write(_filter(_v, rawExpr='$link')) # from line 131, col 23.
                        write('''">''')
                        _v = VFFSL(SL,"name",True) # '$name' on line 131, col 30
                        if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 131, col 30.
                        write('''</a><br />
''')
                    write('''          </span>
''')
                write('''        </th>
        <th>''')
                _v = VFFSL(SL,"node.ostype",True) # '$node.ostype' on line 136, col 13
                if _v is not None: write(_filter(_v, rawExpr='$node.ostype')) # from line 136, col 13.
                write('''</th>
        <th>''')
                _v = VFFSL(SL,"node.osversion",True) # '$node.osversion' on line 137, col 13
                if _v is not None: write(_filter(_v, rawExpr='$node.osversion')) # from line 137, col 13.
                write('''</th>
        <th>

         <table align="right" style="border: 1px solid black; width: 200px; text-align: center;">
          <tr class="nodash">
           <td style="background-color: white; width: 60px; text-align: center;">
            ''')
                if False:
                    _("Total:")
                _v = VFFSL(SL,"_",False)("Total:") # '$_("Total:")' on line 143, col 13
                if _v is not None: write(_filter(_v, rawExpr='$_("Total:")')) # from line 143, col 13.
                write(''' <a href="#" onclick="javascript:showRowsAll(\'''')
                _v = VFFSL(SL,"entry",True) # '${entry}' on line 143, col 71
                if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 143, col 71.
                write('''_''')
                _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 143, col 80
                if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 143, col 80.
                write('''\'); return false;">''')
                _v = VFFSL(SL,"node",True)["total"] # '$node["total"]' on line 143, col 115
                if _v is not None: write(_filter(_v, rawExpr='$node["total"]')) # from line 143, col 115.
                write('''</a>
           </td>
''')
                for i in ("online", "offline", "unknown", "missing"): # generated from line 145, col 12
                    if VFFSL(SL,"node",True)[VFFSL(SL,"i",True)] > 0: # generated from line 146, col 13
                        write('''           <td class="heartbeat_analyze_sensor_status_''')
                        _v = VFFSL(SL,"i",True) # '$i' on line 147, col 55
                        if _v is not None: write(_filter(_v, rawExpr='$i')) # from line 147, col 55.
                        write('''">
            <a href="#" onclick="javascript:showRowsByClass(\'''')
                        _v = VFFSL(SL,"entry",True) # '${entry}' on line 148, col 62
                        if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 148, col 62.
                        write('''_''')
                        _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 148, col 71
                        if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 148, col 71.
                        write("""', 'tr_""")
                        _v = VFFSL(SL,"i",True) # '${i}' on line 148, col 94
                        if _v is not None: write(_filter(_v, rawExpr='${i}')) # from line 148, col 94.
                        write('''\'); return false;">''')
                        _v = VFFSL(SL,"node",True)[VFFSL(SL,"i",True)] # '$node[$i]' on line 148, col 117
                        if _v is not None: write(_filter(_v, rawExpr='$node[$i]')) # from line 148, col 117.
                        write('''</a>
           </td>
''')
                write('''          </tr>
         </table>

        </th>
      </tr>
     </thead>
    </table>

    <div id="''')
                _v = VFFSL(SL,"entry",True) # '${entry}' on line 160, col 14
                if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 160, col 14.
                write('''_''')
                _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 160, col 23
                if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 160, col 23.
                write('''" style="display: ''')
                _v = VFFSL(SL,"display",True) # '$display' on line 160, col 57
                if _v is not None: write(_filter(_v, rawExpr='$display')) # from line 160, col 57.
                write('''">
    <table id="table_''')
                _v = VFFSL(SL,"entry",True) # '${entry}' on line 161, col 22
                if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 161, col 22.
                write('''_''')
                _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 161, col 31
                if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 161, col 31.
                write('''" style="width: 100%; border: 1px solid black;">
      <tr class="tr_header ''')
                _v = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True)%2] # '$row_classes[$cnt%2]' on line 162, col 28
                if _v is not None: write(_filter(_v, rawExpr='$row_classes[$cnt%2]')) # from line 162, col 28.
                write('''">
       <th>''')
                if False:
                    _("Delete")
                _v = VFFSL(SL,"_",False)("Delete") # '$_("Delete")' on line 163, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Delete")')) # from line 163, col 12.
                write('''</th>
       <th>''')
                if False:
                    _("Name")
                _v = VFFSL(SL,"_",False)("Name") # '$_("Name")' on line 164, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Name")')) # from line 164, col 12.
                write('''</th>
       <th>''')
                if False:
                    _("Model")
                _v = VFFSL(SL,"_",False)("Model") # '$_("Model")' on line 165, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Model")')) # from line 165, col 12.
                write('''</th>
       <th>''')
                if False:
                    _("Version")
                _v = VFFSL(SL,"_",False)("Version") # '$_("Version")' on line 166, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Version")')) # from line 166, col 12.
                write('''</th>
       <th>''')
                if False:
                    _("Class")
                _v = VFFSL(SL,"_",False)("Class") # '$_("Class")' on line 167, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Class")')) # from line 167, col 12.
                write('''</th>
       <th>''')
                if False:
                    _("Last heartbeat")
                _v = VFFSL(SL,"_",False)("Last heartbeat") # '$_("Last heartbeat")' on line 168, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Last heartbeat")')) # from line 168, col 12.
                write('''</th>
       <th style="text-align: center;">''')
                if False:
                    _("Status")
                _v = VFFSL(SL,"_",False)("Status") # '$_("Status")' on line 169, col 40
                if _v is not None: write(_filter(_v, rawExpr='$_("Status")')) # from line 169, col 40.
                write('''</th>
      </tr>
''')
                alisting = VFFSL(SL,"node.analyzers",True)
                write('''     ''')
                _v = VFN(VFFSL(SL,"node.analyzers",True),"sort",False)(analyzer_cmp) # '$node.analyzers.sort(analyzer_cmp)' on line 172, col 6
                if _v is not None: write(_filter(_v, rawExpr='$node.analyzers.sort(analyzer_cmp)')) # from line 172, col 6.
                write('''
''')
                for analyzer in VFFSL(SL,"node.analyzers",True): # generated from line 173, col 6
                    cnt += 1
                    write('''      <tr class="tr_''')
                    _v = VFFSL(SL,"analyzer",True)['status'] # "$analyzer['status']" on line 175, col 21
                    if _v is not None: write(_filter(_v, rawExpr="$analyzer['status']")) # from line 175, col 21.
                    write(''' ''')
                    _v = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True)%2] # '$row_classes[$cnt%2]' on line 175, col 41
                    if _v is not None: write(_filter(_v, rawExpr='$row_classes[$cnt%2]')) # from line 175, col 41.
                    write('''">
       <td style="padding-top: 0px; padding-bottom: 0px;"><input class="checkbox" type="checkbox" name="analyzerid" value="''')
                    _v = VFFSL(SL,"analyzer",True)["analyzerid"] # '$analyzer["analyzerid"]' on line 176, col 124
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["analyzerid"]')) # from line 176, col 124.
                    write('''" /></td>

       <td>
        <a href="#" onclick="javascript:toggleVisibilityUnique(\'''')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 179, col 65
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 179, col 65.
                    write('''_''')
                    _v = VFFSL(SL,"node.node_name",True) # '${node.node_name}' on line 179, col 74
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_name}')) # from line 179, col 74.
                    write('''_''')
                    _v = VFFSL(SL,"analyzer.analyzerid",True) # '${analyzer.analyzerid}' on line 179, col 92
                    if _v is not None: write(_filter(_v, rawExpr='${analyzer.analyzerid}')) # from line 179, col 92.
                    write('''\'); return false;">''')
                    _v = VFFSL(SL,"analyzer.name",True) # '$analyzer.name' on line 179, col 133
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.name')) # from line 179, col 133.
                    write('''</a>
        <span id="''')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 180, col 19
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 180, col 19.
                    write('''_''')
                    _v = VFFSL(SL,"node.node_name",True) # '${node.node_name}' on line 180, col 28
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_name}')) # from line 180, col 28.
                    write('''_''')
                    _v = VFFSL(SL,"analyzer.analyzerid",True) # '${analyzer.analyzerid}' on line 180, col 46
                    if _v is not None: write(_filter(_v, rawExpr='${analyzer.analyzerid}')) # from line 180, col 46.
                    write('''" class="popup_menu">
         - <a href="''')
                    _v = VFFSL(SL,"analyzer.alert_listing",True) # '$analyzer.alert_listing' on line 181, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.alert_listing')) # from line 181, col 21.
                    write('''">''')
                    if False:
                        _("Alert listing")
                    _v = VFFSL(SL,"_",False)("Alert listing") # '$_("Alert listing")' on line 181, col 46
                    if _v is not None: write(_filter(_v, rawExpr='$_("Alert listing")')) # from line 181, col 46.
                    write('''</a><br />
         - <a href="''')
                    _v = VFFSL(SL,"analyzer.heartbeat_listing",True) # '$analyzer.heartbeat_listing' on line 182, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.heartbeat_listing')) # from line 182, col 21.
                    write('''">''')
                    if False:
                        _("Heartbeat listing")
                    _v = VFFSL(SL,"_",False)("Heartbeat listing") # '$_("Heartbeat listing")' on line 182, col 50
                    if _v is not None: write(_filter(_v, rawExpr='$_("Heartbeat listing")')) # from line 182, col 50.
                    write('''</a><br />
         - <a href="''')
                    _v = VFFSL(SL,"analyzer.heartbeat_analyze",True) # '$analyzer.heartbeat_analyze' on line 183, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.heartbeat_analyze')) # from line 183, col 21.
                    write('''">''')
                    if False:
                        _("Heartbeat analysis")
                    _v = VFFSL(SL,"_",False)("Heartbeat analysis") # '$_("Heartbeat analysis")' on line 183, col 50
                    if _v is not None: write(_filter(_v, rawExpr='$_("Heartbeat analysis")')) # from line 183, col 50.
                    write('''</a><br />
        </span>
       </td>
       <td>''')
                    _v = VFFSL(SL,"analyzer",True)["model"] # '$analyzer["model"]' on line 186, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["model"]')) # from line 186, col 12.
                    write('''</td>
       <td>''')
                    _v = VFFSL(SL,"analyzer",True)["version"] # '$analyzer["version"]' on line 187, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["version"]')) # from line 187, col 12.
                    write('''</td>
       <td>''')
                    _v = VFFSL(SL,"analyzer",True)["class"] # '$analyzer["class"]' on line 188, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["class"]')) # from line 188, col 12.
                    write('''</td>
       <td>''')
                    _v = VFFSL(SL,"analyzer",True)["last_heartbeat_time"] # '$analyzer["last_heartbeat_time"]' on line 189, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["last_heartbeat_time"]')) # from line 189, col 12.
                    write('''</td>
       <td style="text-align: center;" class="heartbeat_analyze_sensor_status_''')
                    _v = VFFSL(SL,"analyzer",True)["status"] # '$analyzer["status"]' on line 190, col 79
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["status"]')) # from line 190, col 79.
                    write('''">''')
                    _v = VFFSL(SL,"analyzer",True)["status_meaning"] # '$analyzer["status_meaning"]' on line 190, col 100
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["status_meaning"]')) # from line 190, col 100.
                    write('''</td>
      </tr>
''')
                write('''    </table>
    </div>

    <br />
''')
            write('''  </div>
 </fieldset>

<br />
''')
        write('''
''')
        if len(VFFSL(SL,"locations",True)) > 0: # generated from line 204, col 1
            write('''  <div style="text-align: right; vertical-align: bottom;">
    <input class="checkbox" type="checkbox" name="alerts" /><b>''')
            if False:
                _("Alerts")
            _v = VFFSL(SL,"_",False)("Alerts") # '$_("Alerts")' on line 206, col 64
            if _v is not None: write(_filter(_v, rawExpr='$_("Alerts")')) # from line 206, col 64.
            write('''</b>
    <input class="checkbox" type="checkbox" name="heartbeats" /><b>''')
            if False:
                _("Heartbeats")
            _v = VFFSL(SL,"_",False)("Heartbeats") # '$_("Heartbeats")' on line 207, col 68
            if _v is not None: write(_filter(_v, rawExpr='$_("Heartbeats")')) # from line 207, col 68.
            write('''</b>
    &nbsp;<input type="submit" value="''')
            if False:
                _("Delete")
            _v = VFFSL(SL,"_",False)("Delete") # '$_("Delete")' on line 208, col 39
            if _v is not None: write(_filter(_v, rawExpr='$_("Delete")')) # from line 208, col 39.
            write('''" />
  </div>
''')
        write('''
</div>
</form>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_42738897
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''

''')
        self.main_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_SensorListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(SensorListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(SensorListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(SensorListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=SensorListing()).run()


